//+------------------------------------------------------------------+
//|                                                          RVI.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright "www.forex-tsd.com"
#property  link      "www.forex-tsd.com"

#property  indicator_separate_window
#property  indicator_buffers   2
#property  indicator_color1    Green
#property  indicator_color2    OrangeRed
#property indicator_style2     STYLE_DOT
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern int    RviPeriod         = 13;
extern int    Price             = PRICE_TYPICAL;
extern int    StochasticPeriod  = 10;
extern int    StochasticSlowing =  3;
extern int    StochasticDPeriod =  3;
extern int    SmoothPeriod      =  4;
extern double levelOs           = 20;
extern double levelOb           = 80; 


//
//
//
//
//

double stochRvi[];
double stochRviSignal[];
double rvi[];
double stoch[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,stochRvi);
   SetIndexBuffer(1,stochRviSignal);
   SetIndexBuffer(2,rvi);
   SetIndexBuffer(3,stoch);
   SetLevelValue(0,levelOs);
   SetLevelValue(1,levelOb);
   
   //
   //
   //
   //
   //
   
   IndicatorShortName("StochRvi ("+RviPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][2];
#define _co 0
#define _hl 1

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_co] = iTma(Close[i]-Open[i],SmoothPeriod,i,0);
      work[r][_hl] = iTma(High[i]-Low[i]  ,SmoothPeriod,i,1);
      
      //
      //
      //
      //
      //
      
      double sumco = 0.0; 
      double sumhl = 0.0;
         for(int k=0; k<RviPeriod && (r-k)>=0; k++)
         {
            sumco += work[r-k][_co];
            sumhl += work[r-k][_hl];
         }
         if(sumhl!=0.0)
               rvi[i] = sumco/sumhl;
         else  rvi[i] = 0.0;
         
      double min = rvi[ArrayMinimum(rvi,StochasticPeriod,i)];
      double max = rvi[ArrayMaximum(rvi,StochasticPeriod,i)];
              stoch[i] = 0.5; if (min!=max) stoch[i] = 100.0*(rvi[i]-min)/(max-min); 
           stochRvi[i] = iTma(stoch[i]   ,StochasticSlowing,i,2);
     stochRviSignal[i] = iTma(stochRvi[i],StochasticDPeriod,i,3);
   }

   //
   //
   //
   //
   //
      
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double workTma[][4];
double iTma(double price, double period, int r, int instanceNo=0)
{
   if (ArraySize(workTma)!= Bars) ArrayResize(workTma,Bars); r=Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workTma[r][instanceNo] = price;

      double half = (period+1.0)/2.0;
      double sum  = price;
      double sumw = 1;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = k+1; if (weight > half) weight = period-k;
                sumw  += weight;
                sum   += weight*workTma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}

